/*
 * Copyright (C) 2004 Stefano <stefano@xiaprojects.com>
 */

#ifndef _KTRAYNETWORKER_H_
#define _KTRAYNETWORKER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <qlabel.h>

#include <qtimer.h>
#include <qcombobox.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qfiledialog.h>
#include <kconfig.h>
#include <qcheckbox.h>
#include <klistview.h>
#include <qlistview.h>
//#include <ktabwidget.h>
#include <kicondialog.h>
#include <kiconview.h>
#include <qbuttongroup.h>
#include <qdatetime.h>
#include <qradiobutton.h>

#include "ktn_proc.h"
#include "proc.h"
#include "ktrayneticon.h"


/**
 * @short Application Main Window
 * @author Stefano <stefano@xiaprojects.com>
 * @version 0.1
 */
class KTrayNetworker : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    KTrayNetworker();
    //
    //KConfig * appSessionConfig;
    /**
     * Default Destructor
     */
    virtual ~KTrayNetworker();
    void readConfig(KConfig *Restoring=NULL);
    void saveConfig(KConfig *Restoring=NULL);
    void readProperties(KConfig* config);
    void loadSession(const QString &);
    void resetStatics();
    void createTray(int index);

protected:
 // GUI related
 
 //   QLineEdit	*cSession;
 //   QLabel 	*lTitle;
 //   QComboBox 	*cDevices;
    QComboBox 	*cSpeed;
//    QLineEdit	*eRX;
//    QLineEdit	*cTheme;
//    QLineEdit	*iTheme;
//    QCheckBox	*bRestart;
//    QComboBox	*cTX;
//    QComboBox	*cRX;
//    KListView	*tDevices;
//    KTabWidget	*Pages;
//    KIconView	*gTheme;
//    QPushButton *piTheme;
    
//    QLineEdit	*eTX;
    KConfig 	*Restore;
        
//    KTrayNetIcon *TrayIcon;
    KTrayNetIcon *TrayIcons[10];
    class KTN_User	*UserGUI[10];
    
    QTimer *ElapsedTime;
    long int Status;
    //Proc proc;
    KTN_Proc proc;
    
    float totalIn[10];
    float totalOut[10];
    float scaleTX[10];
    float scaleRX[10];
    float deltaRX[10];
    float deltaTX[10];
    float lastValueTX[10];
    float lastValueRX[10];
    QTime deviceTime[10];
    
    QStringList		devicesLink0;
    QStringList		devicesLink1;
    QStringList		devicesLink2;
    QStringList		devicesLink3;
    QStringList		devicesLink4;

    QStringList		devicesLinkCmd0;
    QStringList		devicesLinkCmd1;
    QStringList		devicesLinkCmd2;
    QStringList		devicesLinkCmd3;
    QStringList		devicesLinkCmd4;
    
    QStringList		devicesiLink0;
    QStringList		devicesiLink1;
    QStringList		devicesiLink2;
    QStringList		devicesiLink3;
    QStringList		devicesiLink4;
    
    QStringList		devicesAutoScale;
    QStringList		devicesList;
    QStringList		devicesName;
    QStringList		devicesTheme;
    QStringList		devicesBase;
    QStringList		devicesType;
    QStringList		devicesScale;
    
    int			devicesThemeType[10];    

public slots:
    void Step();
    void updateDev(const QString &);
    void updateSpeed(const QString &);
    void openTheme();
    void changeTheme(const QString &,const QString &a=QString::null);
    void workStart();
    bool queryClose();
    void askClose();
    void updateTXScale(int);
    void updateRXScale(int);
    void openThemeIcon();
    void themeChange(const QString &);
    void changeThemeBase(const QString &);
    bool queryExit();
    void TrayPopupClick(int id);
    void runWizardAgain();
    void userGUIConfigure(const KTN_User *);
protected:
    void CreateGUI();
    void saveProperties(KConfig* config);
    void runWizard();
    void createTrays();
};

#endif // _KTRAYNETWORKER_H_
